<?php
final class Mix{

	private $varHash;
	private $code;
	private $endStr;
	private $key;
	private $ascii;
	private $useVar;
	private $decode;

//代码去空白
	private function strip_whitespace($content) {
		$stripStr   = '';
		$tokens     = token_get_all($content);
		$last_space = false;
		for ($i = 0, $j = count($tokens); $i < $j; $i++) {
			if (is_string($tokens[$i])) {
				$last_space = false;
				$stripStr  .= $tokens[$i];
			} else {
				switch ($tokens[$i][0]) {
					//过滤各种PHP注释
					case T_COMMENT:
					case T_DOC_COMMENT:
						break;
					//过滤空格
					case T_WHITESPACE:
						if (!$last_space) {
							$stripStr  .= ' ';
							$last_space = true;
						}
						break;
					default:
						$last_space = false;
						$stripStr  .= $tokens[$i][1];
				}
			}
		}
		return $stripStr;
	}

//随机字符生成方法
	private function randVarStr(){
		$str = '0123456789abcdefghijklmnopqrstuvwxyz_ABCDEFGHIJKLMNOPQRSTUVWXYZ€亗儎厗噲墛媽崕彁憭摂晼棙櫄洔潪煚、￥ウЖ┆辈炒刀犯购患骄坷谅媚牌侨墒颂臀闲岩釉罩棕仝圮蒉哙徕沅彐玷殛腱眍镳耱篝貊鼬';
		$count = mt_rand(3,12);
		$randStr = '';
		$i = 0;
		$j = false;
		while($count--){
			if( $j ){
				$randStr .= $str{mt_rand(0,191)};
			}else{
				$randStr .= $str{mt_rand(10,191)};
				$j = true;
			}
			$i++;
		}
		return $randStr;
	}

//生成唯一的变量
	private function createVar(){
		$var = $this->randVarStr();
		if( isset($this->varHash[$var]) ){
			$var = $this->createVar();
		}
		$this->varHash[$var] = true;
		return $var;
	}

//字符串进制转换 8 or 16
	private function ascii_encode($str){
		$i = 0;
		$code = '';
		while(1){
			if( !isset($str{$i}) ) break;
			switch( mt_rand(1,2) ){
				case 1:
					$code .= '\x'.dechex( ord($str{$i}) );
					break;
				case 2:
					$code .= '\\'.decoct( ord($str{$i}) );
					break;
			}
			$i++;
		}
		return '"' . $code . '"';
	}

//字符串随机分割方法
	private function strRandSplit($str){
		$arr = array();
		while(1){
			$num = strlen($str);
			$count = mt_rand(1,$num);
			if( $num > $count ){
				$arr[] = substr( $str, 0, $count );
				$str = substr( $str, -($num - strlen(end($arr))) );
			}else{
				$arr[] = $str;
				break;
			}
		}
		return $arr;
	}

//endString生成方法
	private function endStr(){
		$length = mt_rand(70,100);
		$line = mt_rand(4,12);
		$i = 0;
		$arr = array();
		$arr2 = array();
		$data = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz_';
		while( $i<$line ){
			$str = '';
			for( $n=0; $n<$length; $n++ ){
				$rand = mt_rand(0,52);
				$num = ord($data{$rand});
				if( !isset($arr2[$num][$i]) ){
					$arr2[$num][$i] = '';
				}
				$arr2[$num][$i] .= "{$n},";
				$str .= $data{$rand};
			}
			$arr[] = $str;
			$i++;
		}
		$this->endStr = implode( PHP_EOL, $arr );
		$this->key = array( array( 'length' => $length, 'line' => $line ), $arr2 );
	}

//代码压缩方法
	private function zipZheCode($str){
		switch(mt_rand(1,2)){
			case 1:
				return array( 'gzuncompress', gzcompress($str) );
			case 2:
				return array( 'gzinflate', gzdeflate($str) );
		}
	}

//字符串编码方法
	private function compile($str){
		switch(mt_rand(1,3)){
			case 1:
				return array( 'base64_decode', base64_encode($str) );
			case 2:
				return array( 'str_rot13', str_rot13($str) );
			case 3:
				return array( 'convert_uudecode', convert_uuencode($str) );
		}
	}

//字符串取反
	private function negate($str){
		$i = 0;
		$newStr = '';
		while( isset($str{$i}) ){
			$newStr .= '.~\''.addcslashes(~$str{$i},'\'\\').'\'';
			$i++;
		}
		return ltrim( $newStr, '.' );
	}

//整数进制转换
	private function intEn($int){
		switch(mt_rand(1,3)){
			case 1:
				return '0x'.dechex($int);
			case 2:
				return $int;
			case 3:
				return '0'.decoct($int);
		}
	}

//字符串定位取值方法
	private function  pitchStr($str){
		$end = '';
		$i = 0;
		while( isset($str{$i}) ){
			$data = $this->dataInt($str{$i});
			if( is_int($data) ){
				$end .= '.$GLOBALS[\'' . $this->endStrVar() . '\']{' . $this->intEn($data) . '}';
			}else if( $str{$i} == '\'' || $str{$i} == '\\' ){
				$end .= ".'\\{$str{$i}}'";
			}else{
				$end .= ".'{$str{$i}}'";
			}
			$i++;
		}
		return ltrim( $end, '.' );
	}

//字符串自解码编码方法
	private function strNoCode($str,$ok = true){
		if( $ok ){
			$rand = mt_rand(1,6);
		}else{
			$rand = mt_rand(1,5);
		}
		switch($rand){
			case 1:
				return $this->ascii_encode($str);
			case 2:
				return $this->negate($str);
			case 3:
				return $this->forXor($str);
			case 4:
				return $this->forAnd($str);
			case 5:
				return $this->forOr($str);
			case 6:
				return $this->pitchStr($str);
		}
	}

//生成endStr保存变量
	private function endStrVar(){
		static $endStrVar = null;
		if( $endStrVar == null ){
			$endStrVar = $this->createVar();
		}
		return $endStrVar;
	}

//编码字符数据定位方法
	private function dataInt($s){
		$n = ord($s);
		if( !isset($this->key[1][$n]) ) return $s;
		$rand =  array_rand( $this->key[1][$n], 1 );
		$arr = explode( ',', rtrim( $this->key[1][$n][$rand], ',') );
		if( $rand != 0 ){
			return $arr[array_rand( $arr, 1 )] + ( $rand * ( $this->key[0]['length'] + strlen(PHP_EOL) ) );
		}
		return $arr[array_rand( $arr, 1 )];
	}

//生成decode函数调用方法
	private function decode($method){
		$arr = $this->strRandSplit($method);
		$i = 0;
		while( isset($arr[$i]) ){
			switch( mt_rand(1,2) ){
				case 1:
					$this->decode[$method][$i] = array( false, $arr[$i] );
					break;
				case 2:
					$this->decode[$method][$i] = array( $this->createVar(), $arr[$i] );
					break;
			}
			$i++;
		}
	}

//生成解码方法
 	private function decodeMethod($method){
		$decode = $this->decode[$method];
		$num = count($decode);
		$i = 0;
		$end = '';
		while( $i<$num ){
			if( $decode[$i][0] ){
				if( mt_rand(1,10) < 8 ){
					$end .= '.$GLOBALS[\'' . $decode[$i][0]. '\']';
				}else{
					$end .= '.' . $this->strNoCode($decode[$i][1]);
				}
			}else{
				$end .= '.' . $this->strNoCode($decode[$i][1]);
			}
			$i++;
		}
		return ltrim( $end, '.' );
	}

//字符逆向 &|and 运算
	private function forAnd($str){
		$arr = array();
		$strs = array('','');
		$i = 0;
		$group = array(
			array('1','0'), array('0','0'), array('0','1')
		);
		while( isset($str{$i}) ){
			$bin = (string)decbin( ord($str{$i}) );
			$j = 0;
			$arr[0][$i] = '';
			$arr[1][$i] = '';
			while( isset($bin{$j}) ){
				if( $bin{$j} == '1' ){
					$arr[0][$i] .= 1;
					$arr[1][$i] .= 1;
				}else{
					$g = $group[mt_rand(0,2)];
					$arr[0][$i] .= $g[0];
					$arr[1][$i] .= $g[1];
				}
				$j++;
			}
			$i++;
		}
		$i = 0;
		while( isset($arr[0][$i]) ){
			$strs[0] .= chr( bindec($arr[0][$i]) );
			$strs[1] .= chr( bindec($arr[1][$i]) );
			$i++;
		}
		return '(\'' . addcslashes($strs[0],'\'\\') . '\'&\'' . addcslashes($strs[1],'\'\\') . '\')';
	}

//字符串逆向 ||or 运算
	private function forOr($str){
		$arr = array();
		$i = 0;
		$group = array(
			array('1','0'), array('1','1'), array('0','1')
		);
		$strs = array('','');
		while( isset($str{$i}) ){
			$bin = (string)decbin( ord($str{$i}) );
			$j = 0;
			$arr[0][$i] = '';
			$arr[1][$i] = '';
			while( isset($bin{$j}) ){
				if( $bin{$j} == '1' ){
					$g = $group[mt_rand(0,2)];
					$arr[0][$i] .= $g[0];
					$arr[1][$i] .= $g[1];
				}else{
					$arr[0][$i] .= 0;
					$arr[1][$i] .= 0;
				}
				$j++;
			}
			$i++;
		}
		$i = 0;
		while( isset($arr[0][$i]) ){
			$strs[0] .= chr( bindec($arr[0][$i]) );
			$strs[1] .= chr( bindec($arr[1][$i]) );
			$i++;
		}
		return '(\'' . addcslashes($strs[0],'\'\\') . '\'|\'' . addcslashes($strs[1],'\'\\') . '\')';
	}

//字符串逆向 ^|xor 运算
	private function forXor($str){
		$arr = array();
		$i = 0;
		$strs = array('','');
		$one = array(
			array('0','1'), array('1','0')
		);
		$zero = array(
			array('1','1'), array('0','0')
		);
		while( isset($str{$i}) ){
			$bin = (string)decbin( ord($str{$i}) );
			$j = 0;
			$arr[0][$i] = '';
			$arr[1][$i] = '';
			while( isset($bin{$j}) ){
				if( $bin{$j} == '1' ){
					$g = $one[mt_rand(0,1)];
					$arr[0][$i] .= $g[0];
					$arr[1][$i] .= $g[1];
				}else{
					$g = $zero[mt_rand(0,1)];
					$arr[0][$i] .= $g[0];
					$arr[1][$i] .= $g[1];
				}
				$j++;
			}
			$i++;
		}
		$i = 0;
		while( isset($arr[0][$i]) ){
			$strs[0] .= chr( bindec($arr[0][$i]) );
			$strs[1] .= chr( bindec($arr[1][$i]) );
			$i++;
		}
		return '(\'' . addcslashes($strs[0],'\'\\') . '\'^\'' . addcslashes($strs[1],'\'\\') . '\')';
	}

//混淆数据生成
	public function __construct(){
		$this->endStr();
		$this->decode('convert_uudecode');
		$this->decode('base64_decode');
		$this->decode('str_rot13');
		$this->decode('urldecode');
		$this->decode('gzuncompress');
		$this->decode('gzinflate');
		$this->decode('create_function');
		$this->decode('call_user_func');
		$this->decode('php_sapi_name');
		$this->endStrVar();
		$this->useVar = array(
			'sapi' => $this->createVar(),
			'file' => $this->createVar(),
			'md5' => $this->createVar(),
			'fopen' => $this->createVar(),
			'fread' => $this->createVar(),
			'filesize' => $this->createVar(),
			'fclose' => $this->createVar(),
			'substr' => $this->createVar(),
			'hash' => $this->createVar()
		);
	}

//初始化，传入需要加密的文件名
	public function gainCode($file){
		$fp = fopen( $file, 'rb' );
		if( !flock( $fp, LOCK_SH ) ){
			return false;
		}
		$this->code = rtrim( ltrim( rtrim( ltrim( fread( $fp, filesize($file) ), '<?php' ), '?>') ) );
		flock( $fp, LOCK_UN );
		fclose($fp);
		if( !$this->code ){
			return false;
		}
		return true;
	}

//打包文件
	public function packCode($file){
		$this->mixEnd();
		$fp = fopen( $file, 'wb' );
		if( !flock( $fp, LOCK_EX ) ){
			return false;
		}
		if( fwrite( $fp, $this->code ) == false ){
			flock( $fp, LOCK_UN );
			fclose($fp);
			return false;
		}
		flock( $fp, LOCK_UN );
		fclose($fp);
		return true;
	}

//执行混淆
	private function mixEnd(){
		$this->code = $this->strip_whitespace($this->code);
		$this->mix1();
		$this->mix2();
		$this->mix3();
		$this->mix4();
		$this->copyright();
	}

//添加文件版权信息
	private function copyright(){
		$copyright = <<<EOL

/**
 * 新来的骚年你可以运行下这个文件看看
 * 这里有你想知道的一切
 *
*/

EOL;
		$this->code = '<?php' . $copyright . $this->code;
		$this->code .= PHP_EOL . hash('md5',$this->code);
	}

//混淆代码第一步,进行5-7次代码压缩
	private function mix1(){
		$i = 0;
		$num = mt_rand(5,7);
		while( $i<$num ){
			$name = array(
				 $this->createVar(),
				 $this->createVar(),
				 $this->createVar(),
				 $this->createVar()
			);
			$zip = $this->zipZheCode($this->code);
			$arr = $this->compile($zip[1]);
			$str = "global \${$name[0]},\${$name[1]},\${$name[2]},\${$name[3]};\$";
			$str .= $name[0].'='.$this->decodeMethod('call_user_func').';$'.$name[1].'='.$this->decodeMethod('create_function').';$'.$name[2].'='.$this->decodeMethod($zip[0]).';$'.$name[3].'='.$this->decodeMethod($arr[0]).';';
			$this->code = $str.'$GLOBALS[\''.$name[0].'\']($GLOBALS[\''.$name[1].'\'](\'\',$GLOBALS[\''.$name[2].'\']($GLOBALS[\''.$name[3].'\']('.$this->strNoCode($arr[1]).'))));';
			$i++;
		}
	}

//添加代码守护，防破解
	private function mix2(){
		$js = '请勿随便修改本文件(此文件受花指令算法影响，可修改)';
		$this->code = 'if($GLOBALS[\''.$this->useVar['hash'].'\'](\'md5\',$GLOBALS[\''.$this->useVar['file'].'\']) != $GLOBALS[\''.$this->useVar['md5'].'\']) die(\''.$js.'\');'.$this->code;
		$this->code = 'if($GLOBALS[\''.$this->useVar['sapi'].'\']() == '.$this->strNoCode('cli').' || $GLOBALS[\''.$this->useVar['sapi'].'\']() == '.$this->strNoCode('cgi').' || $GLOBALS[\''.$this->useVar['sapi'].'\']() == '.$this->strNoCode('embed').' || $GLOBALS[\''.$this->useVar['sapi'].'\']() == '.$this->strNoCode('cli-server').') die();'.$this->code;
	}

//添加赋值语句
	private function mix3(){
		$str = '';
		$global = '';
		$len = strlen(PHP_EOL);
		foreach($this->decode as $v){
			$i = 0;
			while( isset($v[$i]) ){
				if( $v[$i][0] ){
					$global .= '$'.$v[$i][0].',';
					$str .= '$'.$v[$i][0].'='.$this->strNoCode($v[$i][1]).';';
				}
				$i++;
			}
		}
		$var = $this->createVar();
		$var1 = $this->createVar();
		$global = 'global '.$global.'$'.$this->endStrVar().',$'.$this->useVar['sapi'].',$'.$this->useVar['file'].',$'.$this->useVar['md5'].';';
		$num = ($this->key[0]['length']+$len)*$this->key[0]['line']-$len;
		$str = $global.'$'.$var.'=$GLOBALS[\''.$this->useVar['fopen'].'\']('.$this->useVar['file'].','.$this->strNoCode('rb',false).');$'.$var1.'=$GLOBALS[\''.$this->useVar['fread'].'\']($'.$var.',$GLOBALS[\''.$this->useVar['filesize'].'\']('.$this->useVar['file'].'));$GLOBALS[\''.$this->useVar['fclose'].'\']($'.$var.');$'.$this->useVar['md5'].'=$GLOBALS[\''.$this->useVar['substr'].'\']($'.$var1.',-32,32);$'.$this->useVar['file'].'=$GLOBALS[\''.$this->useVar['substr'].'\']($'.$var1.',0,-'.(32 + $len).');$'.$this->endStrVar().'=$GLOBALS[\''.$this->useVar['substr'].'\']($'.$var1.',-'.($num+32+$len).','.$num.');'.$str.'$'.$this->useVar['sapi'].'='.$this->strNoCode('php_sapi_name').';';
		$this->code = $str.$this->code;
	}

//收尾混淆
	private function mix4(){
		$i = 0;
		$num = mt_rand(5,7);
		while( $i<$num ){
			$name = array(
				 '$'.$this->createVar(),
				 '$'.$this->createVar(),
				 '$'.$this->createVar(),
				 '$'.$this->createVar()
			);
			$zip = $this->zipZheCode($this->code);
			if( $i == ($num-1) ){
				$arr = array( 'str_rot13', str_rot13($zip[1]) );
				$str = $name[0].'='.$this->strNoCode('call_user_func',false).';'.$name[1].'='.$this->strNoCode('create_function',false).';'.$name[2].'='.$this->strNoCode($zip[0],false).';'.$name[3].'='.$this->strNoCode($arr[0],false).';';
			}else{
				$arr = $this->compile($zip[1]);
				$str = $name[0].'='.$this->strNoCode('call_user_func',false).';'.$name[1].'='.$this->strNoCode('create_function',false).';'.$name[2].'='.$this->strNoCode($zip[0],false).';'.$name[3].'='.$this->strNoCode($arr[0],false).';';
			}

			$this->code = $str.$name[0].'('.$name[1].'(\'\','.$name[2].'('.$name[3].'(\''.addcslashes($arr[1],'\'\\').'\'))));';
			$i++;
		}
		$arr = array(
			'$'.$this->useVar['fopen'].'='.$this->strNoCode('fopen',false),
			'$'.$this->useVar['fread'].'='.$this->strNoCode('fread',false),
			'$'.$this->useVar['filesize'].'='.$this->strNoCode('filesize',false),
			'$'.$this->useVar['fclose'].'='.$this->strNoCode('fclose',false),
			'$'.$this->useVar['substr'].'='.$this->strNoCode('substr',false),
			'$'.$this->useVar['hash'].'='.$this->strNoCode('hash',false)
		);
		shuffle($arr);
		$str = implode(';',$arr);
		$this->code = 'error_reporting(0);ini_set(\'display_errors\',0);define(\''.$this->useVar['file'].'\',__FILE__);'.$str.';'.$this->code . 'return;?>' . PHP_EOL . $this->endStr;
	}

}

//使用方法
$r = new Mix();
if( $r->gainCode('phpinfo.php') ){ //需要加密的文件路径
	$r->packCode('one.php'); //加密后文件的路径
}
